package com.peup;

import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.springframework.batch.core.Job;
import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.JobParameters;
import org.springframework.batch.core.JobParametersBuilder;
import org.springframework.batch.core.JobParametersInvalidException;
import org.springframework.batch.core.launch.JobLauncher;
import org.springframework.batch.core.repository.JobInstanceAlreadyCompleteException;
import org.springframework.batch.core.repository.JobRestartException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.peup.service.util.DataValueException;
import com.peup.service.util.SpringPropertiesUtil;
import com.peup.service.util.UtilGenerateCsv;

public class AppPeup {
//	private final static String PROGRAM_HELP = "Usage is: program ";
	private final static Logger logger = Logger.getLogger(AppPeup.class);
	public static Map MESSAGESLOG = new HashMap();

	static JobParameters jobParameters = null;
	static JobExecution execution = null;
	static JobLauncher jobLauncher = null;
	static Job job = null;
	static String[] springConfig = { "spring/batch/config/context.xml",
			"spring/batch/jobs/job-report.xml" };

	public static void main(String[] args) throws Exception,
			JobRestartException, JobInstanceAlreadyCompleteException,
			JobParametersInvalidException {

		ApplicationContext context = new ClassPathXmlApplicationContext(
				springConfig);
		jobLauncher = (JobLauncher) context.getBean("jobLauncher");
		job = (Job) context.getBean("reportJob");
		traitement1();
	}

	private static void traitement1() throws ParseException, DataValueException {
		jobParameters = new JobParametersBuilder().addLong("time",
				System.currentTimeMillis()).toJobParameters();
		try {		
			execution = jobLauncher.run(job, jobParameters);
			logger.info("Exit Status : " + execution.getStatus());

		} catch (Exception e) {
			logger.error(e.getMessage());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, e.getMessage());
			UtilGenerateCsv.generateCsvFile(
					SpringPropertiesUtil.getProperty("file.output.log"),
					AppPeup.MESSAGESLOG);
			throw new DataValueException("Global Error");
		}
		logger.info("Done");
	}
}
