package com.peup.dao.impl;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import com.peup.dto.DossierRedevableExport;
import org.apache.log4j.Logger;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.datasource.DataSourceUtils;
import org.springframework.stereotype.Repository;

import com.peup.entity.Dossier;

@Repository
public class JdbcDossierRedevableDAO{
	private final static Logger logger = Logger.getLogger(JdbcDossierRedevableDAO.class);
    private JdbcTemplate varJdbcTemplate;	
	
	public Dossier updateTemplate(DossierRedevableExport t) {
		String sql = "update dossier_2 set siret = %s where dossier_id = %d";
		sql=String.format(sql,t.getSiretDossier(),t.getDossierRedevableDto().getDossierId());
		logger.info(sql);
		try {
			execUpdate(sql);
		} catch (SQLException e) {
			logger.info(e);
		}
		return null;
	}
	
	public void execUpdate(String sql) throws SQLException {
		Connection conn = DataSourceUtils.getConnection(varJdbcTemplate
				.getDataSource());
		Statement stmt = conn.createStatement();
		stmt.executeUpdate(sql);
		conn.commit();
	}


	public JdbcTemplate getVarJdbcTemplate() {
		return varJdbcTemplate;
	}


	public void setVarJdbcTemplate(JdbcTemplate varJdbcTemplate) {
		this.varJdbcTemplate = varJdbcTemplate;
	}
	
	
}
