package com.peup.listener;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.batch.core.ItemWriteListener;

import com.peup.AppPeup;
import com.peup.service.util.UtilGenerateCsv;

public class CustomItemWriterListener implements
		ItemWriteListener<Object> {
	private final static Logger logger = Logger
			.getLogger(CustomItemWriterListener.class);
	List<String> listError = new ArrayList<String>();

	public void beforeWrite(List<? extends Object> items) {
		logger.info("ItemWriteListener - beforeWrite");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "beforeWrite");
	}

	public void afterWrite(List<? extends Object> items) {
		logger.info("ItemWriteListener - afterWrite");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "afterWrite");
	}

	public void onWriteError(Exception exception,
			List<? extends Object> items) {
		logger.info("ItemWriteListener - onWriteError");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, "onWriteError");
	}

}
