package com.peup.listener;

import org.apache.log4j.Logger;
import org.springframework.batch.core.listener.SkipListenerSupport;

import com.peup.AppPeup;
import com.peup.service.util.SpringPropertiesUtil;
import com.peup.service.util.UtilGenerateCsv;

public class CustomSkipListener extends SkipListenerSupport<Object, Object> {
	private final static Logger logger = Logger
			.getLogger(CustomSkipListener.class);

	@Override
	public void onSkipInRead(Throwable arg0) {
		logger.info("Skip - onSkipInRead");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "onSkipInRead");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, arg0.getMessage());
		UtilGenerateCsv.generateCsvFile(
				SpringPropertiesUtil.getProperty("file.output.log"),
				AppPeup.MESSAGESLOG);
	}

	@Override
	public void onSkipInWrite(Object arg0, Throwable arg1) {
		logger.info("Skip - onSkipInWrite");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "onSkipInWrite");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, arg1.getMessage());

		UtilGenerateCsv.generateCsvFile(
				SpringPropertiesUtil.getProperty("file.output.log"),
				AppPeup.MESSAGESLOG);


	}

	@Override
	public void onSkipInProcess(Object arg0, Throwable arg1) {
		
		logger.info("Skip - onSkipInProcess");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "onSkipInProcess");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, arg1.getMessage());
		UtilGenerateCsv.generateCsvFile(
				SpringPropertiesUtil.getProperty("file.output.log"),
				AppPeup.MESSAGESLOG);

	}
}
