package com.peup.listener;

import org.apache.log4j.Logger;
import org.springframework.batch.core.BatchStatus;
import org.springframework.batch.core.ExitStatus;
import org.springframework.batch.core.StepExecution;
import org.springframework.batch.core.StepExecutionListener;

import com.peup.AppPeup;
import com.peup.service.util.SpringPropertiesUtil;
import com.peup.service.util.UtilGenerateCsv;

public class CustomStepListener implements StepExecutionListener {

	
	private final static Logger logger = Logger
			.getLogger(CustomStepListener.class);

	public void beforeStep(StepExecution stepExecution) {
		logger.info("StepExecutionListener - beforeStep");

		if (stepExecution.getStatus() == BatchStatus.COMPLETED) {
			logger.info("step completed: id:" + stepExecution.getId()
					+ " name:" + stepExecution.getStepName());
		} else if (stepExecution.getStatus() == BatchStatus.FAILED) {
			logger.info("step failed: id:" + stepExecution.getId() + " name:"
					+ stepExecution.getStepName());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_ID,
					stepExecution.getId());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME,
					stepExecution.getStepName());

			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_EXIT_STATUS,
					stepExecution.getExitStatus().getExitCode());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_EXIT_DESCRIPTION,
					stepExecution.getExitStatus().getExitDescription());
			UtilGenerateCsv.generateCsvFile(
					SpringPropertiesUtil.getProperty("file.output.log"),
					AppPeup.MESSAGESLOG);
		}
	}

	public ExitStatus afterStep(StepExecution stepExecution) {
		logger.info("StepExecutionListener - afterStep");
		if (stepExecution.getStatus() == BatchStatus.COMPLETED) {
			logger.info("step completed: id:" + stepExecution.getId()
					+ " name:" + stepExecution.getStepName());
		} else if (stepExecution.getStatus() == BatchStatus.FAILED) {
			logger.info("step failed: id:" + stepExecution.getId() + " name:"
					+ stepExecution.getStepName());

			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_ID,
					stepExecution.getId());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME,
					stepExecution.getStepName());

			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_EXIT_STATUS,
					stepExecution.getExitStatus().getExitCode());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_EXIT_DESCRIPTION,
					stepExecution.getExitStatus().getExitDescription());
			UtilGenerateCsv.generateCsvFile(
					SpringPropertiesUtil.getProperty("file.output.log"),
					AppPeup.MESSAGESLOG);
		}
		return null;
	}

}
