package com.peup.service.impl;

import java.util.List;
import java.util.Map;

import com.peup.dto.DossierRedevableExport;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.peup.dao.impl.DossierDao;
import com.peup.dao.impl.JdbcDossierRedevableDAO;
import com.peup.entity.Dossier;
import com.peup.service.IDossierRedevableService;

@Service
@Transactional(readOnly = true)
public class DossierRedevableService implements IDossierRedevableService<Dossier> {
	@Autowired
	private DossierDao dossierDao;	
	@Autowired	
	private JdbcDossierRedevableDAO jdbcDossierRedevableDAO;

	public DossierRedevableService() {
	}

	// ---------generic-------
	public long countAll(Map<String, Object> params) {
		return dossierDao.countAll(params);
	}

	@Transactional(readOnly = false,propagation= Propagation.REQUIRED)
	public Dossier create(Dossier t) {
		return dossierDao.create(t);
	}

	@Transactional(readOnly = false,propagation= Propagation.REQUIRED)
	public void delete(Object id) {
		dossierDao.delete(id);

	}

	public Dossier find(Object id) {
		return dossierDao.find(id);
	}

	public List<Dossier> find(Map<String, Object> params) {
		return dossierDao.find(params);
	}
	@Transactional(readOnly = false,propagation= Propagation.REQUIRED)
	public Dossier update(Dossier t) {
		return dossierDao.update(t);
	}	

	public Dossier updateTemplate(DossierRedevableExport t) {
		return jdbcDossierRedevableDAO.updateTemplate(t);
	}	
	
	
	
	
	
	
	

}
