package com.peup.service.util;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Map;

import com.peup.service.util.csvreader.CsvWriter;

public class UtilGenerateCsv {

	public static String TIME = "TIME";	
	public static String DOSSIER_ID = "DOSSIER_ID";
	public static String REDEVABLE_ID = "REDEVABLE_ID";
	public static String ADRESSE = "ADRESSE";
	public static String CODE_SIRET = "CODE_SIRET";	
	
	public static String STEP_ID = "STEP_ID";
	public static String STEP_NAME = "STEP_NAME";
	public static String STEP_EXIT_STATUS = "STEP_EXIT_STATUS";
	public static String STEP_EXIT_DESCRIPTION = "STEP_EXIT_DESCRIPTION";
	public static String JOB_ID = "JOB_ID";
	public static String JOB_NAME = "JOB_NAME";
	public static String JOB_EXIT_STATUS = "JOB_EXIT_STATUS";
	public static String JOB_EXIT_DESCRIPTION = "JOB_EXIT_DESCRIPTION";
	public static String JOB_START_TIME = "JOB_START_TIME";
	public static String JOB_END_TIME = "JOB_END_TIME";
	public static String ERROR = "ERROR";

	public static void generateCsvFile(String outputFile, Map map) {
		// before we open the file check to see if it already exists
		boolean alreadyExists = new File(outputFile).exists();
		try {
			// use FileWriter constructor that specifies open for appending
			CsvWriter csvOutput = new CsvWriter(
					new FileWriter(outputFile, true), ';');

			// if the file didn't already exist then we need to write out the
			// header line
			if (!alreadyExists) {
				// Time
				// DocumentId
				// StepId
				// StepName
				// StepExitStatus
				// StepExitDescription
				// JobId
				// JobName
				// JobExitStatus
				// JobExitDescription
				// JobStartTime
				// JobEndTime
				// StepName
				// Error

				csvOutput.write(TIME);
				csvOutput.write(DOSSIER_ID);
				csvOutput.write(REDEVABLE_ID);
				csvOutput.write(REDEVABLE_ID);
				csvOutput.write(CODE_SIRET);
				csvOutput.write(STEP_ID);
				csvOutput.write(STEP_NAME);
				csvOutput.write(STEP_EXIT_STATUS);
				csvOutput.write(STEP_EXIT_DESCRIPTION);
				csvOutput.write(JOB_ID);
				csvOutput.write(JOB_NAME);
				csvOutput.write(JOB_EXIT_STATUS);
				csvOutput.write(JOB_EXIT_DESCRIPTION);
				csvOutput.write(JOB_START_TIME);
				csvOutput.write(JOB_END_TIME);
				csvOutput.write(ERROR);

				csvOutput.endRecord();
			}
			// else assume that the file already has the correct header line

			// write out a few records
			csvOutput.write(UtilService.getCurrentDate().toString());

			csvOutput.write(map.get(DOSSIER_ID) != null ? map.get(DOSSIER_ID)
					.toString() : "--");
			csvOutput.write(map.get(REDEVABLE_ID) != null ? map.get(REDEVABLE_ID)
					.toString() : "--");			
			csvOutput.write(map.get(REDEVABLE_ID) != null ? map.get(REDEVABLE_ID)
					.toString() : "--");
			csvOutput.write(map.get(CODE_SIRET) != null ? map.get(CODE_SIRET)
					.toString() : "--");			
			csvOutput.write(map.get(STEP_ID) != null ? map.get(STEP_ID)
					.toString() : "--");
			csvOutput.write(map.get(STEP_NAME) != null ? map.get(STEP_NAME)
					.toString() : "--");
			csvOutput.write(map.get(STEP_EXIT_STATUS) != null ? map.get(
					STEP_EXIT_STATUS).toString() : "--");
			csvOutput.write(map.get(STEP_EXIT_DESCRIPTION) != null ? map.get(
					STEP_EXIT_DESCRIPTION).toString() : "--");
			csvOutput.write(map.get(JOB_ID) != null ? map.get(JOB_ID)
					.toString() : "--");
			csvOutput.write(map.get(JOB_NAME) != null ? map.get(JOB_NAME)
					.toString() : "--");
			csvOutput.write(map.get(JOB_EXIT_STATUS) != null ? map.get(
					JOB_EXIT_STATUS).toString() : "--");
			csvOutput.write(map.get("JobExitDescription") != null ? map.get(
					"JobExitDescription").toString() : "--");
			csvOutput.write(map.get(JOB_EXIT_DESCRIPTION) != null ? map.get(
					JOB_EXIT_DESCRIPTION).toString() : "--");
			csvOutput.write(map.get(JOB_START_TIME) != null ? map.get(
					JOB_START_TIME).toString() : "--");
			csvOutput.write(map.get(ERROR) != null ? map.get(ERROR).toString()
					: "--");

			csvOutput.endRecord();
			csvOutput.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}
