package com.peup.service.util;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Map;

import com.peup.service.util.csvreader.CsvWriter;

public class UtilGenerateCsvResult {
	public static String TIME = "TIME";
	public static String DOSSIER_ID = "DOSSIER_ID";
	public static String REDEVABLE_ID = "REDEVABLE_ID";
	public static String ADRESSE = "ADRESSE";
	public static String CODE_SIRET = "CODE_SIRET";
	public static String FILE_SOURCE = "FILE_SOURCE";

	public static void generateCsvFile(String outputFile, Map<?, ?> map) {
		// before we open the file check to see if it already exists
		boolean alreadyExists = new File(outputFile).exists();
		try {
			// use FileWriter constructor that specifies open for appending
			CsvWriter csvOutput = new CsvWriter(new FileWriter(outputFile, true), ';');

			// if the file didn't already exist then we need to write out the
			// header line
			if (!alreadyExists) {
				csvOutput.write(TIME);
				csvOutput.write(DOSSIER_ID);
				csvOutput.write(REDEVABLE_ID);
				csvOutput.write(ADRESSE);
				csvOutput.write(CODE_SIRET);
				csvOutput.write(FILE_SOURCE);
				csvOutput.endRecord();
			}
			// else assume that the file already has the correct header line

			// write out a few records
			csvOutput.write(UtilService.getCurrentDate().toString());
			csvOutput.write(map.get(DOSSIER_ID) != null ? map.get(DOSSIER_ID).toString() : "--");
			csvOutput.write(map.get(REDEVABLE_ID) != null ? map.get(REDEVABLE_ID).toString() : "--");
			csvOutput.write(map.get(ADRESSE) != null ? map.get(ADRESSE).toString() : "--");
			csvOutput.write(map.get(CODE_SIRET) != null ? map.get(CODE_SIRET).toString() : "--");
			csvOutput.write(map.get(FILE_SOURCE) != null ? map.get(FILE_SOURCE).toString() : "--");

			csvOutput.endRecord();
			csvOutput.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}
